%%-------------------------------------- SCRIPT FOR MAKEING HILL-DIAGRAM ---------------------------------------%
L={1:5 6:10 11:15 16:20 21:25};                                 % POSITIONS FOR DIFFEREN NOZZLE OPENINGS        %
%% ----------------------------- SURFACE FITTING HILL FOR DIFFERENT NOZZLE OPENINGS ----------------------------%
for i=1:ceil(length(data.q11_1(:,1))/5)                         % VARYING OPENING FOR 1 TO 5 NOZZLES            %
    Q=[max(ceil(data.q11_1(L{i}(1),:)*10)/10)...                                                                %
        mean(data.q11_1(L{i}(2:length(L{i})-1),:)')...                                                          %
        min(floor(data.q11_1(L{i}(length(L{i})),:)*10)/10)];    % ROUNDS VOLUME FLOW FOR SPECIFIC NOZZLE CONF.  %
    q_min=min(Q);                                               % FINDS MINIMUM Q_11                            %
    q_max=max(Q);                                               % FINDS MAXIMUM Q_11                            %
    q11=min(Q):0.1:max(Q);                                      % Q_11 SPAN WITH HIGHER RESOLUTION              %
    n11=37.7:0.2:45.2;                                          % N_11 SPAN WITH NORMAL RESOLUTION              %
                                                                                                                %
    temp1=interp2(mean(data.q11_1(L{i},:)')'...                 %|                                              %
        ,mean(data.n11_1(L{i},:)),...                           %|SURFACE FITS THE HILL DIAGRAM FOR THE         %
        data.etta_1(L{i},:)',q11,n11','spline',0);              %|NOZZLE CONFIGURATION                          %
                                                                                                                %    
    data.surf{i}.n11=n11';                                      % STORES THE N_11 SPAN                          %
    data.surf{i}.q11=q11;                                       % STORES THE Q_11 SPAN                          %
    data.surf{i}.etta=temp1;                                    % STORES THE FITTED EFFICIENCY                  %
    data.surf{i}.q_min=q_min;                                   % STORES MINIMUM Q_11                           %
    data.surf{i}.q_max=q_max;                                   % STORES MAXIMUM Q_11                           %
end                                                                                                             %
                                                                                                                %
                                                                                                                %
clear n11 q11 q_min q_max temp1 Q L                             % CLEAR TEMPORARY VARIABLES                     %
%% --------------- FILTERS FOR BEST EFFICIENCY AT ALL Q_11 ------------------------%
pos(1:5)=1;                                                     % SETS THE POSITION IN ALL FITS = 1             %
v=1;                                                            % SETS COUNTER = 1                              %
L=data.surf{1}.q_min:0.1:data.surf{5}.q_max;                    % HIGH RESOLUTION Q_11 VECTOR                   %
S1=data.surf{1};                                                % IMPORTS SURFACE FIT FOR 1 NOZZLE              %
S2=data.surf{2};                                                % IMPORTS SURFACE FIT FOR 2 NOZZLE              %
S3=data.surf{3};                                                % IMPORTS SURFACE FIT FOR 3 NOZZLE              %
S4=data.surf{4};                                                % IMPORTS SURFACE FIT FOR 4 NOZZLE              %
S5=data.surf{5};                                                % IMPORTS SURFACE FIT FOR 5 NOZZLE              %
data.hill.n11=S1.n11(:,1);                                      % SETS N_11 SPAN FOR COMPLETE HILL DIAGRAM      %
n11=data.hill.n11;                                              % STORES TEMPORARY N_11 VECTOR                  %
etta_max.etta=0;                                                % MAX EFFICIENTY VARIABLE                       %
shift(1:length(n11),1:5)=0;                                     % VECTOR TO STORE NOZZLE SHIFTS                 %
for i=1:count(L,'>0')                                           % LOOP THROUGH ALL Q_11 POINTS                  %
    data.hill.q11(1,i)=L(i);                                                                                    %
    for j=1:length(n11)                                         % LOOP THROUGH ALL N_11 POINTS                  %
%%------------------------------------- IF Q_11 IS ONLY FOR 1 NOZZLE -------------------------------------------%    
    if v<count(L,strcat('<',num2str(data.surf{2}.q_min)))                                                       %
        data.hill.etta(j,v)=S1.etta(j,pos(1));                  % SETS EFFICIENCY IN COMPLETE HILL              %
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(1)=pos(1)+1;                                    % MOVES POSITION IN SURFACE FOR 1 NOZZLE        %
        end                                                                                                     %
%%------------------------------------- IF Q_11 IS FOR 1 OR 2 NOZZLE -------------------------------------------%    
    elseif v>=count(L,strcat('<',num2str(S2.q_min))) &&...                                                      %
            v<count(L,strcat('<',num2str(S3.q_min)))                                                            %
        if S2.etta(j,pos(2))>S1.etta(j,pos(1))                  % IF 2 NOZZLES ARE BETTER THEN 1                %
            data.hill.etta(j,v)=S2.etta(j,pos(2));              % SETS EFFICIENCY IN COMPLETER HILL             %
            if shift(j,2)==0                                    % IF SHIFT FROM 1 TO 2 NOZZLES                  %
                shift(j,2)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        else                                                    % IF 1 NOZZLE IS BETTER THEN 2                  %
            data.hill.etta(j,v)=S1.etta(j,pos(1));              % SETS EFFICIENCY IN COMPLETER HILL             %
        end                                                                                                     %
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(1)=pos(1)+1;                                    % MOVES POSITION IN SURFACE FOR 1 NOZZLE        %
            pos(2)=pos(2)+1;                                    % MOVES POSITION IN SURFACE FOR 2 NOZZLE        %
        end                                                                                                     %
%%------------------------------------- IF Q_11 IS FOR 1, 2 OR 3 NOZZLE ----------------------------------------%    
    elseif v>=count(L,strcat('<',num2str(S3.q_min))) &&...                                                      %
            v<=count(L,strcat('<=',num2str(S1.q_max))) &&...                                                    %
            v<=count(L,strcat('<',num2str(S4.q_min)))                                                            %
        etta_m=S1.etta(j,pos(1));                               % SETS EFFICIENCY FOR 1 NOZZLE AS REFERENCE     %
        if S2.etta(j,pos(2))>etta_m                             % IF 2 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S2.etta(j,pos(2));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,2)==0                                    % IF SHIFT FROM 1 TO 2 NOZZLES                  %
                shift(j,2)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %

        elseif S3.etta(j,pos(3))>etta_m                         % IF 3 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S3.etta(j,pos(3));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,3)==0                                    % IF SHIFT FROM 2 TO 3 NOZZLES                  %
                shift(j,3)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        else                                                    % IF 1 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S1.etta(j,pos(1));              % SETS EFFICIENCY IN COMPLETER HILL             %
        end                                                                                                     %
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(1)=pos(1)+1;                                    % MOVES POSITION IN SURFACE FOR 1 NOZZLE        %
            pos(2)=pos(2)+1;                                    % MOVES POSITION IN SURFACE FOR 2 NOZZLE        %
            pos(3)=pos(3)+1;                                    % MOVES POSITION IN SURFACE FOR 3 NOZZLE        %
        end                                                                                                     %
%%------------------------------------- IF Q_11 IS FOR 1, 2, 3 OR 4 NOZZLE--------------------------------------%    
    elseif v>=count(L,strcat('<=',num2str(S4.q_min))) &&...                                                     %
            v<=count(L,strcat('<=',num2str(S1.q_max)))                                                          %
        etta_m=S1.etta(j,pos(1));                               % SETS EFFICIENCY FOR 1 NOZZLE AS REFERENCE     %
        if S2.etta(j,pos(2))>etta_m                             % IF 2 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S2.etta(j,pos(2));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,2)==0                                    % IF SHIFT FROM 1 TO 2 NOZZLES                  %
                shift(j,2)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        elseif S3.etta(j,pos(3))>etta_m                         % IF 3 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S3.etta(j,pos(3));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,3)==0                                    % IF SHIFT FROM 2 TO 3 NOZZLES                  %
                shift(j,3)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        elseif S4.etta(j,pos(4))>etta_m                         % IF 4 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S4.etta(j,pos(4));              % SETS EFFICIENCY IN COMPLETER HILL             %
            if shift(j,4)==0                                    % IF SHIFT FROM 3 TO 4 NOZZLES                  %
                shift(j,4)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        else                                                    % IF 1 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S1.etta(j,pos(1));              % SETS EFFICIENCY IN COMPLETER HILL             %
        end                                                                                                     %
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(1)=pos(1)+1;                                    % MOVES POSITION IN SURFACE FOR 1 NOZZLE        %
            pos(2)=pos(2)+1;                                    % MOVES POSITION IN SURFACE FOR 2 NOZZLE        %
            pos(3)=pos(3)+1;                                    % MOVES POSITION IN SURFACE FOR 3 NOZZLE        %
            pos(4)=pos(4)+1;                                    % MOVES POSITION IN SURFACE FOR 4 NOZZLE        %
        end                                                                                                     %
%%------------------------------------- IF Q_11 IS FOR 2, 3 OR 4 NOZZLE ----------------------------------------%
    elseif v>count(L,strcat('<',num2str(S1.q_max))) &&...                                                       %
            v<count(L,strcat('<=',num2str(S5.q_min)))                                                            %
        etta_m=S2.etta(j,pos(2));                               % SETS EFFICIENCY FOR 2 NOZZLE AS REFERENCE     %
        if S3.etta(j,pos(3))>etta_m                             % IF 3 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S3.etta(j,pos(3));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,3)==0                                    % IF SHIFT FROM 2 TO 3 NOZZLES                  %
                shift(j,3)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        elseif S4.etta(j,pos(4))>etta_m                         % IF 4 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S4.etta(j,pos(4));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,4)==0                                    % IF SHIFT FROM 3 TO 4 NOZZLES                  %
                shift(j,4)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        else                                                    % IF 2 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S2.etta(j,pos(2));              % SETS EFFICIENCY IN COMPLETER HILL             %
            if shift(j,2)==0                                    % IF SHIFT FROM 1 TO 2 NOZZLES                  %
                shift(j,2)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        end                                                                                                     %
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(2)=pos(2)+1;                                    % MOVES POSITION IN SURFACE FOR 2 NOZZLE        %
            pos(3)=pos(3)+1;                                    % MOVES POSITION IN SURFACE FOR 3 NOZZLE        %
            pos(4)=pos(4)+1;                                    % MOVES POSITION IN SURFACE FOR 4 NOZZLE        %
        end                                                                                                     %
%%------------------------------------- IF Q_11 IS FOR 2, 3, 4 OR 5 NOZZLE -------------------------------------%
    elseif v>=count(L,strcat('<=',num2str(S5.q_min))) &&...                                                     %
            v<=count(L,strcat('<',num2str(S2.q_max)))                                                           %
        etta_m=S2.etta(j,pos(2));                               % SETS EFFICIENCY FOR 2 NOZZLE AS REFERENCE     %
        if S3.etta(j,pos(3))>etta_m                             % IF 3 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S3.etta(j,pos(3));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,3)==0                                    % IF SHIFT FROM 2 TO 3 NOZZLES                  %
                shift(j,3)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        elseif S4.etta(j,pos(4))>etta_m                         % IF 4 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S4.etta(j,pos(4));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,4)==0                                    % IF SHIFT FROM 3 TO 4 NOZZLES                  %
                shift(j,4)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        elseif S5.etta(j,pos(5))>etta_m                         % IF 4 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S5.etta(j,pos(5));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,5)==0                                    % IF SHIFT FROM 4 TO 5 NOZZLES                  %
                shift(j,5)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        else                                                    % IF 1 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S2.etta(j,pos(2));              % SETS EFFICIENCY IN COMPLETER HILL             %
            if shift(j,2)==0                                    % IF SHIFT FROM 1 TO 2 NOZZLES                  %
                shift(j,2)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        end                                                                                                     %
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(2)=pos(2)+1;                                    % MOVES POSITION IN SURFACE FOR 2 NOZZLE        %
            pos(3)=pos(3)+1;                                    % MOVES POSITION IN SURFACE FOR 3 NOZZLE        %
            pos(4)=pos(4)+1;                                    % MOVES POSITION IN SURFACE FOR 4 NOZZLE        %
            pos(5)=pos(5)+1;                                    % MOVES POSITION IN SURFACE FOR 5 NOZZLE        %
        end                                                                                                     %
%%------------------------------------- IF Q_11 IS FOR 3, 4 OR 5 NOZZLE ----------------------------------------%
    elseif v<=count(L,strcat('<=',num2str(S3.q_max))) &&...                                                      %
            v>=count(L,strcat('<=',num2str(S5.q_min)))                                                          %
        etta_m=S4.etta(j,pos(4));                               % SETS EFFICIENCY FOR 4 NOZZLE AS REFERENCE     %
        if S3.etta(j,pos(3))>etta_m                             % IF 3 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S3.etta(j,pos(3));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,3)==0                                    % IF SHIFT FROM 2 TO 3 NOZZLES                  %
                shift(j,3)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        elseif S5.etta(j,pos(5))>etta_m                         % IF 3 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S5.etta(j,pos(5));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,5)==0                                    % IF SHIFT FROM 4 TO 5 NOZZLES                  %
                shift(j,5)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        else                                                    % IF 4 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S4.etta(j,pos(4));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,4)==0                                    % IF SHIFT FROM 3 TO 4 NOZZLES                  %
                shift(j,4)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        end                                                                                                     %
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(3)=pos(3)+1;                                    % MOVES POSITION IN SURFACE FOR 3 NOZZLE        %
            pos(4)=pos(4)+1;                                    % MOVES POSITION IN SURFACE FOR 4 NOZZLE        %
            pos(5)=pos(5)+1;                                    % MOVES POSITION IN SURFACE FOR 5 NOZZLE        %
        end                                                                                                     %
%%------------------------------------- IF Q_11 IS FOR 4 OR 5 NOZZLE -------------------------------------------%
    elseif v>count(L,strcat('<=',num2str(S3.q_max))) &&...                                                      %
            v<(count(L,strcat('<=',num2str(S4.q_max)))+1)                                                       %
        etta_m=S4.etta(j,pos(4));                               % SETS EFFICIENCY FOR 4 NOZZLE AS REFERENCE     %
        if S5.etta(j,pos(5))>etta_m                             % IF 3 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=S5.etta(j,pos(5));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,5)==0                                    % IF SHIFT FROM 4 TO 5 NOZZLES                  %
                shift(j,5)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        else                                                    % IF 4 NOZZLES ARE BETTER                       %
            data.hill.etta(j,v)=etta_m;                         % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,4)==0                                    % IF SHIFT FROM 3 TO 4 NOZZLES                  %
                shift(j,4)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        end
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(4)=pos(4)+1;                                    % MOVES POSITION IN SURFACE FOR 4 NOZZLE        %
            pos(5)=pos(5)+1;                                    % MOVES POSITION IN SURFACE FOR 5 NOZZLE        %
        end                                                                                                     %
%%------------------------------------- IF Q_11 IS FOR 5 NOZZLE ------------------------------------------------%
    elseif v>count(L,strcat('<=',num2str(S4.q_max)))                                                            %
            data.hill.etta(j,v)=S5.etta(j,pos(5));              % SETS EFFICIENCY OF COMPLETE HILL              %
            if shift(j,5)==0                                    % IF SHIFT FROM 3 TO 4 NOZZLES                  %
                shift(j,5)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        if j==length(n11)                                       % IF THE Q_11 POINT IS FINISHED                 %
            pos(5)=pos(5)+1;                                    % MOVES POSITION IN SURFACE FOR 5 NOZZLE        %
            if shift(j,5)==0                                    % IF SHIFT FROM 4 TO 5 NOZZLES                  %
                shift(j,5)=L(i);                                % STORES Q11 VALUE @ SHIFT                      %
            end                                                                                                 %
        end                                                                                                     %
    end                                                                                                         %
%%-------------------------------- SAVES POSITION OF MAX EFFICIENCY---------------------------------------------%
    if data.hill.etta(j,v)>etta_max.etta                        % IF HIGHER EFFICIENCY                          %
        etta_max.etta=data.hill.etta(j,v);                      % SAVES MAX EFFICIENCY                          %
        etta_max.q11=L(i);                                      % SAVES Q11 VALUE                               %
        etta_max.n11=n11(j);                                    % SAVES N11 VALUE                               %
        etta_max.pos=[j v]                                      % SAVES POSITION                                %
    end                                                                                                         %
%%--------------------------------------------------------------------------------------------------------------%
    end                                                                                                         %
    v=v+1;                                                      % MOVES COUNTER                                 %
end                                                                                                             %
data.hill.shift=shift;                                           % STORES SHIFT VECTOR                           %
clear v pos i etta_m S1 S2 S3 N11 Q11 Q_t L                     % CLEARS TEMPORARY VARIABLES                    %
%% -------------------------------------------------------------------------------------------------------------%